/*
 * RT6_Agenda.cmd - written by mira308sw
 *
 * script to read/write Agenda.dat file with usb device.
 *
 * v01.00 09/04/2011 :  first release
 * v01.01 02/09/2012 :  remove load agenda function and go back to reboot.
 *                      "LoadData" don't work on RT6
 * v01.02 01/11/2013 :  remove reboot at the end
 */

#define RTX_DIR       "/SDI/user_data/Agenda"
#define USB_DIR       "/bd0"
#define DAT_FILE      "/Agenda.dat"
#define INF_FILE      DAT_FILE ".inf"
#define NO            0
#define YES           1
#define OK            0
#define ERROR        -1
#define NULL          (void*)0

int     GetFileSize               (char* file, int* size);
int     ShowNavigationQuestionScreen (char* text, int* answer);
int     UPGCopy                   ( char *src,char *dst,int cut );
char*   strcpy                    ( char *dst,char *src );
char*   strcat                    ( char *dst,char *src );
void    RebootSystem              ( void );

int   main ( int argc,char* argv[] )
{
  int   size;
  int   answ=NO;
  char  l_sPath[256];
  char  l_sPathInf[256];

  strcpy( l_sPath,argv[1] );
  strcat( l_sPath,DAT_FILE );
  if( GetFileSize( l_sPath,&size )==OK )
    ShowNavigationQuestionScreen( "WRITE " DAT_FILE " ?",&answ );
  else
  {
    strcpy( l_sPath,USB_DIR );
    strcat( l_sPath,DAT_FILE );
    if( GetFileSize( l_sPath,&size )==OK )
      ShowNavigationQuestionScreen( "WRITE " DAT_FILE " ?",&answ );
  }

  if( answ==YES )
  {
    strcpy( l_sPathInf,l_sPath );
    strcat( l_sPathInf,".inf" );
    if( UPGCopy( l_sPath   ,RTX_DIR DAT_FILE,0 )!=OK ||
        UPGCopy( l_sPathInf,RTX_DIR INF_FILE,0 )!=OK )
      ShowNavigationQuestionScreen( "Error coping files",&answ );
    else 
	{
      ShowNavigationQuestionScreen( "Copy completed, long press EJECT to reboot",&answ );
//	  RebootSystem();
	}
  }
  else
  {
    ShowNavigationQuestionScreen( "READ " DAT_FILE " ?",&answ );
    if( answ==YES )
    {
      if( UPGCopy( RTX_DIR DAT_FILE,USB_DIR DAT_FILE,0 )!=OK ||
          UPGCopy( RTX_DIR INF_FILE,USB_DIR INF_FILE,0 )!=OK )
        ShowNavigationQuestionScreen( "Error coping files",&answ );
      else
        ShowNavigationQuestionScreen( "Copy completed.",&answ );
    }
    else
      ShowNavigationQuestionScreen( "Finish.",&answ );
  }
  return OK;
}
