/*
 * RT6_CONFIGFLAG.CMD  by mira308sw
 *
 *
 * Change some configuration flag for RT6
 *
 * v 1.00: 08/04/2011   first release
 * v 1.01: 14/06/2012	remove file update after modify flags
 * v 1.02: 01/11/2013	remove flag SR from list
 */

typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;

typedef int                     BOOL;

typedef void                    DIR;
typedef void                    FILE;

typedef enum { ERROR=-1,OK=0 }  STATUS;

#define NULL                    (void*)0
#define TRUE                    1
#define FALSE                   0


char*   strcat                  ( char *dest,char *s );
char*   strcpy                  ( char *dest,char *src );

/* Functions and data types from MMI module
 */
#define NO                            0
#define YES                           1

STATUS  ClearScreen                   ( void );
STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );

void    RebootSystem              ( void );
void*   UPGFindSymbol             ( char *sym );



/* these functions work only on modified Builtinsrneg.out crc=e49f2d91
 * this is a method to call any function, throw modified AddUPGHistoryCommentary
 * function
 * GFC = GenericFunctionCall
 */
int     AddUPGHistoryCommentary	 ( void *funptr,... );   // max 7 parameters
#define GFC                             AddUPGHistoryCommentary
#define GETDBBOOTCONFIGSYSTEMFLAG(f,i)  GFC( pf_getflag,f,i )
#define SETDBBOOTCONFIGSYSTEMFLAG(f,i)  GFC( pf_setflag,f,i )
void *pf_sprintf;
void *pf_getflag;
void *pf_setflag;

STATUS InitFunctionPtr ( void )
{
  int   l_iAnsw;

  pf_sprintf    =UPGFindSymbol( "sprintf" );
  pf_getflag    =UPGFindSymbol( "InterGetDBBootConfigSystemFlag__FRcUi" );
  pf_setflag    =UPGFindSymbol( "InterSetDBBootConfigSystemFlag__FcUi" );

  if( pf_sprintf    !=NULL &&
      pf_getflag    !=NULL &&
      pf_setflag    !=NULL )
  {
      return OK;
  }
  ShowNavigationQuestionScreen( "InitFunctionPtr() FAILED!", &l_iAnsw );
  return ERROR;
}

int   ChangeConfigFlag  ( int p_index,char *p_name )
{
  int   l_answ;
  int	  l_mod = FALSE;
  char  l_txt[80];
  char  l_val;
  char  l_new;

  if( ERROR==GETDBBOOTCONFIGSYSTEMFLAG( &l_val,p_index ) )
    ShowNavigationQuestionScreen( "Error in GetConfigSystemFlag",&l_answ );
  while( 1 )
  {
    l_new = l_val+1;
    if( l_new>2 )
      l_new = 0;
    GFC( pf_sprintf,l_txt,"%s=%d, Change to %d?",p_name,l_val,l_new );
    ShowNavigationQuestionScreen( l_txt,&l_answ );
    if( l_answ!=YES )
      break;
    l_val = l_new;
    l_mod = TRUE;
  }
  if( l_mod==TRUE )
  {
    if( ERROR==SETDBBOOTCONFIGSYSTEMFLAG( l_val,p_index ) )
      ShowNavigationQuestionScreen( "Error in SetConfigSystemFlag",&l_answ );
  }
  return l_mod;
}

int main ( int argc,char *argv[] )
{
  int   l_answ;

  if( InitFunctionPtr()!=OK )
    return OK;

  l_answ =ChangeConfigFlag( 0x00,"USB"       );
  l_answ+=ChangeConfigFlag( 0x01,"UNKNOWN1"  );
  l_answ+=ChangeConfigFlag( 0x02,"DVD"       );
  l_answ+=ChangeConfigFlag( 0x03,"BT"        );
  l_answ+=ChangeConfigFlag( 0x04,"BT_AGENDA" );
  l_answ+=ChangeConfigFlag( 0x05,"SIRIUS"    );
  l_answ+=ChangeConfigFlag( 0x06,"IPOD"      );
  l_answ+=ChangeConfigFlag( 0x07,"FMUX"      );
  l_answ+=ChangeConfigFlag( 0x08,"AUDIO_AUX" );
  l_answ+=ChangeConfigFlag( 0x09,"CDC"       );
//  l_answ+=ChangeConfigFlag( 0x0A,"SR"        ); // too many RT6 bricked by this flag
  l_answ+=ChangeConfigFlag( 0x0B,"JBX"       );
  l_answ+=ChangeConfigFlag( 0x0C,"TRIP"      );
  l_answ+=ChangeConfigFlag( 0x0D,"CLIM"      );
  l_answ+=ChangeConfigFlag( 0x0E,"VIDEO_AUX" );
  l_answ+=ChangeConfigFlag( 0x0F,"AAS"       );
  l_answ+=ChangeConfigFlag( 0x10,"AVR" 	     );
  l_answ+=ChangeConfigFlag( 0x11,"A2DP"      );
  l_answ+=ChangeConfigFlag( 0x12,"UNKNOWN2"  );
  l_answ+=ChangeConfigFlag( 0x13,"MERCOSUR"  );

  if( l_answ==0 )
    ShowNavigationQuestionScreen( "Nothing changed",&l_answ );
  else
  {
    ShowNavigationQuestionScreen( "Complete! Reboot ?",&l_answ );
    if( l_answ==YES )
      RebootSystem();
  }
  ClearScreen();
  return OK;
}

